import psspyObject


def run_case():
    # Present Finland case
    s = 1  # Scaling factor, s = 0.98 limit w/o disconnect, 0.98 with disconnect
    vyborg_load = -1420 * s  # Vyborg Link 1420, minus sign means import
    estlink_load = -1000 * s  # EstLink 1000
    case_southern_finland = psspyObject.PsspyCase("test_pgu_ufls_interaction")
    case_southern_finland.configure_case_options(False, 20.0, 0, 10, True, False)
    case_southern_finland.add_ufls([[7000]],[[49.8, 0.1, 49.6, 0.1, 49.4, 0.1]])
    #case_southern_finland.add_uvls()
    # case_southern_finland.add_uvls_and_ufls()  # Can't find the needed model name :(
    case_southern_finland.set_hvdc_active_power_and_redistribute(7010, vyborg_load)  # Vyborg Link 1420
    case_southern_finland.set_hvdc_active_power_and_redistribute(7020, estlink_load)  # EstLink 1000
    # case_southern_finland.disconnect_inactive_generators()
    case_southern_finland.run_static_load_flow()
    case_southern_finland.save_network_data()
    case_southern_finland.add_event(1.0, 2, 7010, [-vyborg_load])  # Step active power to 0 and reactive power to 0
    case_southern_finland.add_event(1.0, 2, 7020, [-estlink_load])
    case_southern_finland.prepare_dynamic_simulation(0.005)
    case_southern_finland.monitor_channels([3300, 5600, 7000, 8500], [1, 2, 4, 7], (3300, 5600, 7000, 7010, 7020, 8500), (1,2,4), [[3359, 3359], [5101, 3100]])
    # case_southern_finland.monitor_channels([3300, 5600], [1, 2, 4, 7], [7000, 8500])
    #case_southern_finland.add_demand_response(0.9, 49.5)
    case_southern_finland.add_programmable_generation(7000, "pgu_ufls_interaction")
    #case_southern_finland.add_programmable_generation(7100)
    case_southern_finland.run_dynamic_simulation()
    case_southern_finland.read_results()
    case_southern_finland.calculate_coi_frequency()
    case_southern_finland.plot_results_and_save()
