import psspyObject


def run_case():
    # Outage in Norway with low system inertia and maximum outage of NL and NSL without any kind of SIPS

# CONFIGURE PSSPY VARIABLES AND MODELS
    s = 1.30
    vyborg_load = -1420 * s  # Vyborg Link 1420
    estlink_load = -1000 * s  # EstLink 1000
    current_case = psspyObject.PsspyCase("case3_survive_osf_vyborg_estlink")
    current_case.configure_case_options(False, 9.0, 0, 10, True, False)

# STATIC LOAD FLOW ADJUSTMENTS
    current_case.reduce_load_by_x_percentage(0.3)  # 0.1 = 10%
    current_case.add_hvdc_buses()
    current_case.set_hvdc_active_power_and_redistribute(7010, vyborg_load)  # Vyborg Link 1420
    current_case.set_hvdc_active_power_and_redistribute(7020, estlink_load)  # EstLink 1000
    current_case.disconnect_inactive_generators_fixed()
    current_case.increase_gen_to_decrease_slack_bus_output(0.1)  # Necessary so slack bus doesn't go crazy
    current_case.run_static_load_flow()
    current_case.save_network_data()

# PREPARATION FOR DYNAMIC ANALYSIS
    current_case.add_event(0.1, 2, 7010, [-vyborg_load])  # Step active power to 0 and reactive power to 0
    current_case.add_event(0.1, 2, 7020, [-estlink_load])
    current_case.prepare_dynamic_simulation(0.005)
    current_case.monitor_channels([3000, 3115, 3245, 3249, 3300, 3359, 5100, 5600, 6000, 6500,
                                   6700, 7000], [1, 2, 4, 7], (3000, 3100, 3115, 3200, 3245, 3249,
     3300, 3359, 5100, 5500, 5600, 6000, 6500, 6700, 7000, 8500), (1, 4), [[3359, 3359], [5101, 3100]])  # For all angles for clustering

# RUN SIMULATION AND POST-PROCESS
    current_case.run_dynamic_simulation()
    current_case.read_results()
    current_case.calculate_coi_frequency()
    current_case.plot_results_and_save()
