import psspyObject


def run_case():
    # Outage in Norway without any kind of SIPS

# CONFIGURE PSSPY VARIABLES AND MODELS
    s = 1.75  # 1.15 is highest that converges
    north_sea_link_load = -1400 * s  # North Sea Link 1400 MW, minus sign means import
    nord_link_load = -1400 * s  # NordLink 1400 MW
    current_case = psspyObject.PsspyCase("case4_osf_uvls_outage_norway")
    current_case.configure_case_options(False, 90.0, 0, 10, True, False)

# STATIC LOAD FLOW ADJUSTMENTS
    current_case.add_hvdc_buses()
    current_case.add_uvls()
    current_case.set_hvdc_active_power_and_redistribute(6010, north_sea_link_load)  # Set North Sea Link import to 1400 MW
    current_case.set_hvdc_active_power_and_redistribute(5630, nord_link_load)  # Set Nord Link import to 1400 MW
    current_case.disconnect_inactive_generators()
    current_case.run_static_load_flow()
    current_case.save_network_data()

# PREPARATION FOR DYNAMIC ANALYSIS
    current_case.add_event(1.0, 2, 6010, [-north_sea_link_load])  # Step active power to 0 and reactive power to 0
    current_case.add_event(1.0, 2, 5630, [-nord_link_load])
    current_case.prepare_dynamic_simulation(0.005)
    current_case.monitor_channels([3000, 5600, 7000, 8500], [1, 2, 4, 6, 7], (3000, 3020, 3100, 3249, 5600, 5630, 6010, 7000, 7100), (1,2,4), [[3359, 3359], [5101, 3100]])

# RUN SIMULATION AND POST-PROCESS
    current_case.run_dynamic_simulation()
    current_case.read_results()
    current_case.calculate_coi_frequency()
    current_case.plot_results_and_save()
