import sys
import numpy as np
from datetime import datetime
sys.path.insert(0, 'M:\Documents\master_thesis_psse_python\PSSPY\PycharmProject\Master cases')
import case1_outage_norway_with_ufls_hvdc_dsr as dsr_case

dsr_percentages = np.linspace(0.0, 0.5, 11)  # Percentages of system load used for DSR
np.savetxt("frequency_y_axis_dsr_percentages_with_ufls_hvdc_dsr.txt", dsr_percentages)  # Y-axis for frequency data corresponding to percentage of DSR

dsr_time_delays = np.linspace(0.01, 5.0, 11)  # Time delay for DSR in seconds, start at 0.01 as 0.0 is faulty
np.savetxt("frequency_x_axis_dsr_time_delay_with_ufls_hvdc_dsr.txt", dsr_time_delays)  # X-axis for frequency data corresponding to time-delay

frequency_nadirs_plot_data = []  # Frequency nadirs in Hz resulting from the simulations
frequency_steady_state_plot_data = []  # Steady-state frequencies in Hz taken from the end of the COI-frequency

start_time = datetime.now()

breakpoint = 1

for i in range(len(dsr_time_delays)):
    nadir_freq = []
    ss_freq = []
    dsr_percentage_freq_nadir_and_ss = []
    for j in range(len(dsr_percentages)):
        dsr_percentage_freq_nadir_and_ss.append(dsr_case.run_case(dsr_percentages[j], dsr_time_delays[i]))
        nadir_freq.append(dsr_percentage_freq_nadir_and_ss[j][0])
        ss_freq.append(dsr_percentage_freq_nadir_and_ss[j][1])

    # Frequency data
    frequency_nadirs_plot_data.append(nadir_freq)
    frequency_steady_state_plot_data.append(ss_freq)
    np.savetxt("results_frequency_nadirs_plot_data_case1_with_ufls_hvdc_dsr.txt", frequency_nadirs_plot_data)
    np.savetxt("results_frequency_steady_state_plot_data_case1_with_ufls_hvdc_dsr.txt", frequency_steady_state_plot_data)

    print(datetime.now() - start_time)

